#include <sourcemod>
#include <sdktools>
#include <multicolors>
#include <autoexecconfig>
#include <sdkhooks>
#include <cstrike>
#include <adminmenu>

#pragma semicolon 1

#define DEBUG

#pragma newdecls required


public Plugin myinfo = 
{
	name = "Wall Hack Round", 
	author = "LanteJoula", 
	description = "Wall Hack Round", 
	version = "1.2", 
	url = "https://steamcommunity.com/id/lantejoula/"
};

char g_ChatPrefix[256];
ConVar gConVar_Chat_Prefix;

ConVar gConVar_StartRound_Message;
ConVar gConVar_RoundEnd_Message;

ConVar gConVar_StaffForceStop_Message;


//ADMIN ESP

#define HEADSCALE 1.0
#define HEADPROP "models/player/holiday/facemasks/facemask_tf2_spy_model.mdl"
#define HEADATTACH "facemask"

#define NORMATTACH "primary"

ConVar cColor[2];
ConVar cLifeState;
ConVar cTeam;
ConVar cModel;

int colors[2][4];

bool isUsingESP[MAXPLAYERS + 1];
bool canSeeESP[MAXPLAYERS + 1];
int playersInESP = 0;
ConVar sv_force_transmit_players;

int playerModels[MAXPLAYERS + 1] = { INVALID_ENT_REFERENCE, ... };
int playerModelsIndex[MAXPLAYERS + 1] = { -1, ... };

int playerTeam[MAXPLAYERS + 1] = { 0, ... };

#define EF_BONEMERGE                (1 << 0)

//ADMIN MENU

Handle hAdminMenu;

//MODES MENU

bool WallhackRound = false;

public void OnPluginStart()
{
	LoadTranslations("wallhackround.phrases");
	
	//EVENTOS
	HookEvent("round_end", OnRoundEnd);
	
	//Open Menu
	RegAdminCmd("sm_wallhackround", WallHackRoundMenu, ADMFLAG_GENERIC);
	RegAdminCmd("sm_whr", WallHackRoundMenu, ADMFLAG_GENERIC);
	RegAdminCmd("sm_wallhack", WallHackRoundMenu, ADMFLAG_GENERIC);
	RegAdminCmd("sm_wh", WallHackRoundMenu, ADMFLAG_GENERIC);
	
	//CONVARS
	AutoExecConfig_SetFile("plugin.wallhackround");
	
	gConVar_Chat_Prefix = AutoExecConfig_CreateConVar("sm_wallhackround_chat_prefix", "{green}[TAG]{default}", "Chat Prefix");
	
	
	gConVar_StartRound_Message = AutoExecConfig_CreateConVar("sm_wallhackround_prestartround_message", "1", "Enable/Disable Message when Round Start (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_RoundEnd_Message = AutoExecConfig_CreateConVar("sm_wallhackround_roundend_message", "1", "Enable/Disable Message when Round End (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	
	gConVar_StaffForceStop_Message = AutoExecConfig_CreateConVar("sm_wallhackround_forcestop_message", "1", "Enable/Disable Message when Staff Force Stop Round (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	
	AutoExecConfig_ExecuteFile();
	AutoExecConfig_CleanFile();
	
	gConVar_Chat_Prefix.AddChangeHook(OnPrefixChange);
	
	
	//ADMIN ESP
	
	sv_force_transmit_players = FindConVar("sv_force_transmit_players");
	cColor[0] = AutoExecConfig_CreateConVar("sm_wallhackround_tcolor", "255 1 255", "Determines R G B glow colors for Terrorists team\nFormat should be \"R G B\" (with spaces)", 0);
	cColor[1] = AutoExecConfig_CreateConVar("sm_wallhackround_ctcolor", "255 1 255", "Determines R G B glow colors for Counter-Terrorists team\nFormat should be \"R G B\" (with spaces)", 0);
	cLifeState = AutoExecConfig_CreateConVar("sm_wallhackround_lifestate1", "2", "Set to 1 if admins should only see esp when dead, 2 to only see esp while alive, 0 dead or alive.", FCVAR_DONTRECORD, true, 0.0, true, 1.0);
	cTeam = AutoExecConfig_CreateConVar("sm_wallhackround_team", "0", "0 - Display all teams, 1 - Display enemy, 2 - Display teammates", FCVAR_DONTRECORD, true, 0.0, true, 1.0);
	cModel = AutoExecConfig_CreateConVar("sm_wallhackround_model", "0", "0 - Use current model (full body glow), 1 - Use facemask model on head", FCVAR_DONTRECORD, true, 0.0, true, 1.0);
	cColor[0].AddChangeHook(ConVarChange);
	cColor[1].AddChangeHook(ConVarChange);
	cLifeState.AddChangeHook(ConVarChange);
	cTeam.AddChangeHook(ConVarChange);
	cModel.AddChangeHook(ConVarChange);
	
	for (int i = 0; i <= 1; i++)
	{
		retrieveColorValue(i);
	}
	
	HookEvent("player_spawn", Event_PlayerSpawn);
	HookEvent("player_death", Event_PlayerDeath);
	HookEvent("round_end", Event_RoundEnd);
	
	//RegPluginLibrary
	RegPluginLibrary("wallhackround");
}

////////
//Prefix
////////

public void SavePrefix()
{
	GetConVarString(gConVar_Chat_Prefix, g_ChatPrefix, sizeof(g_ChatPrefix));
}

public void OnConfigsExecuted()
{
	SavePrefix();
}

public void OnPrefixChange(ConVar cvar, char[] oldvalue, char[] newvalue)
{
	SavePrefix();
}

//PLUGIN
//PLUGIN
//PLUGIN

public void OnMapStart()
{
	//ADMIN ESP
	PrecacheModel(HEADPROP);
	resetPlayerVars(0);
}

public void OnClientDisconnect(int client)
{
	//ADMIN ESP
	resetPlayerVars(client);
}

public void OnClientPutInServer(int client)
{
	//ADMIN ESP
	resetPlayerVars(client);
	
	
	//FIXBUG WHEN PLAYER JOIN ON SERVER ON WALLHACK ROUND
	if (WallhackRound)
	{
		Command_ESP(client, 0);
	}
}




/////////////////
//MODE STAFF MENU
/////////////////

public Action WallHackRoundMenu(int client, int args)
{
	ShowMenu(client);
}

void ShowMenu(int client)
{
	char StartVote1[128];
	char PreStartMenu1[128];
	char ForceStopMenu1[128];
	
	Menu menu = new Menu(Menu_Handler);
	menu.SetTitle("%t\n ", "Wall Hack Round Title");
	
	Format(StartVote1, sizeof(StartVote1), "%t", "StartVote");
	menu.AddItem("1", StartVote1);
	
	if (!WallhackRound)
	{
		Format(PreStartMenu1, sizeof(PreStartMenu1), "%t", "PreStartMenu");
		menu.AddItem("2", PreStartMenu1);
	}
	else
	{
		Format(ForceStopMenu1, sizeof(ForceStopMenu1), "%t", "ForceStopMenu");
		menu.AddItem("3", ForceStopMenu1);
	}
	menu.ExitButton = true;
	menu.Display(client, MENU_TIME_FOREVER);
}

public int Menu_Handler(Menu menu, MenuAction action, int client, int args)
{
	if (action == MenuAction_Select)
	{
		char selectedItem[200];
		menu.GetItem(args, selectedItem, sizeof(selectedItem));
		if (StrEqual(selectedItem, "1"))
		{
			FakeClientCommand(client, "sm_vote \"%t\"", "WallHackRoundVote");
		}
		if (StrEqual(selectedItem, "2"))
		{
			if (GetUserFlagBits(client))
			{
				WallhackRound = true;
				
				char name[128];
				GetClientName(client, name, sizeof(name));
				
				if (gConVar_StartRound_Message.BoolValue)
					CPrintToChatAll("%s %t", g_ChatPrefix, "StartRound", name);
				
				for (int i = 1; i <= MaxClients; i++)
				{
					if (IsClientInGame(i))
					{
						Command_ESP(i, 0);
					}
				}
			}
		}
		if (StrEqual(selectedItem, "3"))
		{
			if (GetUserFlagBits(client))
			{
				WallhackRound = false;
				
				char name[128];
				GetClientName(client, name, sizeof(name));
				
				if (gConVar_StaffForceStop_Message.BoolValue)
					CPrintToChatAll("%s %t", g_ChatPrefix, "ForceStop", name);
				
				for (int i = 1; i <= MaxClients; i++)
				{
					if (IsClientInGame(i))
					{
						Command_ESP(i, 0);
					}
				}
			}
		}
	}
	else if (action == MenuAction_End)
	{
		delete menu;
	}
}

//EVENTS


public Action OnRoundEnd(Event event, const char[] name, bool dontBroadcast)
{
	if (WallhackRound)
	{
		if (gConVar_RoundEnd_Message.BoolValue)
			CPrintToChatAll("%s %t", g_ChatPrefix, "RoundEnd");
		
		WallhackRound = false;
		
		for (int i = 1; i <= MaxClients; i++)
		{
			if (IsClientInGame(i))
			{
				Command_ESP(i, 0);
			}
		}
	}
}


//ADMIN ESP

public void OnPluginEnd()
{
	destoryGlows();
}

public void Event_PlayerTeam(Event event, const char[] name, bool dontBroadcast)
{
	int client = GetClientOfUserId(event.GetInt("userid"));
	
	if (client <= 0 || client > MaxClients || !IsClientInGame(client))
	{
		return;
	}
	
	playerTeam[client] = GetClientTeam(client);
}

public void Event_PlayerSpawn(Event event, const char[] name, bool dontBroadcast)
{
	int client = GetClientOfUserId(event.GetInt("userid"));
	
	if (client <= 0 || client > MaxClients || !IsClientInGame(client))
	{
		return;
	}
	
	if (isUsingESP[client])
	{
		if (cLifeState.IntValue != 1)
		{
			canSeeESP[client] = true;
		}
		else
		{
			canSeeESP[client] = false;
		}
	}
	checkGlows();
}

public void Event_PlayerDeath(Event event, const char[] name, bool dontBroadcast)
{
	if (cLifeState.IntValue != 2) {
		
		int client = GetClientOfUserId(event.GetInt("userid"));
		
		if (client > 0 && client <= MaxClients && IsClientInGame(client) && isUsingESP[client])
		{
			canSeeESP[client] = true;
		}
	}
	checkGlows();
}

public void Event_RoundEnd(Event event, const char[] name, bool dontBroadcast)
{
	destoryGlows();
}

public void ConVarChange(ConVar convar, const char[] oldValue, const char[] newValue) {
	for (int i = 0; i <= 1; i++)
	{
		if (convar == cColor[i])
		{
			retrieveColorValue(i);
		}
	}
	checkGlows();
}

public void retrieveColorValue(int index)
{
	char pieces[4][16];
	char color[64];
	cColor[index].GetString(color, sizeof(color));
	if (ExplodeString(color, " ", pieces, sizeof(pieces), sizeof(pieces[])) >= 3)
	{
		for (int j = 0; j < 3; j++)
		{
			colors[index][j] = StringToInt(pieces[j]);
		}
	}
}

public Action Command_ESP(int client, int args)
{
	if (!client || !IsClientInGame(client))
	{
		return Plugin_Handled;
	}
	
	if (args > 0)
	{
		toggleGlow(client, isUsingESP[client]);
	}
	else
	{
		toggleGlow(client, !isUsingESP[client]);
	}
	
	return Plugin_Handled;
}

public void toggleGlow(int client, bool value)
{
	isUsingESP[client] = value;
	
	checkGlows();
}

public void resetPlayerVars(int client)
{
	if (client == 0)
	{
		for (int i = 1; i <= MaxClients; i++)
		{
			resetPlayerVars(i);
		}
		return;
	}
	
	isUsingESP[client] = false;
	playerTeam[client] = 0;
	
	if (IsClientInGame(client))
	{
		playerTeam[client] = GetClientTeam(client);
	}
}

public bool getCanSeeEsp(int client, int lifestate)
{
	switch (lifestate)
	{
		case 1:return !IsPlayerAlive(client);
		case 2:return IsPlayerAlive(client);
	}
	
	return true;
}

public void checkGlows()
{
	playersInESP = 0;
	int lifestate = cLifeState.IntValue;
	
	for (int client = 1; client <= MaxClients; client++)
	{
		if (!IsClientInGame(client) || !isUsingESP[client])
		{
			isUsingESP[client] = false;
			canSeeESP[client] = false;
			continue;
		}
		
		canSeeESP[client] = getCanSeeEsp(client, lifestate);
		
		if (canSeeESP[client])
		{
			playersInESP++;
		}
	}
	
	destoryGlows();
	
	if (playersInESP > 0)
	{
		sv_force_transmit_players.SetString("1", true, false);
		createGlows();
	}
	else
	{
		sv_force_transmit_players.SetString("0", true, false);
	}
}

public void destoryGlows()
{
	for (int client = 1; client <= MaxClients; client++)
	{
		if (IsClientInGame(client))
		{
			RemoveSkin(client);
		}
	}
}

public void createGlows()
{
	char model[PLATFORM_MAX_PATH];
	char attachment[PLATFORM_MAX_PATH];
	int skin = -1;
	int showTeam = cTeam.IntValue;
	int useModel = cModel.IntValue;
	float scale = 1.0;
	
	if (useModel)
	{
		model = HEADPROP;
		attachment = HEADATTACH;
		scale = HEADSCALE;
	}
	else
	{
		attachment = NORMATTACH;
	}
	for (int client = 1; client <= MaxClients; client++)
	{
		if (!IsClientInGame(client) || !IsPlayerAlive(client))
		{
			continue;
		}
		playerTeam[client] = GetClientTeam(client);
		if (playerTeam[client] <= 1)
		{
			continue;
		}
		if (!useModel)
		{
			GetClientModel(client, model, sizeof(model));
		}
		skin = CreatePlayerModelProp(client, model, attachment, !useModel, scale);
		if (skin > MaxClients)
		{
			playerTeam[client] = GetClientTeam(client);
			if (showTeam == 1)
			{
				
				if (playerTeam[client] == 3 && SDKHookEx(skin, SDKHook_SetTransmit, OnSetTransmit_T) || 
					playerTeam[client] == 2 && SDKHookEx(skin, SDKHook_SetTransmit, OnSetTransmit_CT))
				{
					setGlowTeam(skin, playerTeam[client]);
				}
			}
			else if (showTeam == 2) {
				
				if (playerTeam[client] == 2 && SDKHookEx(skin, SDKHook_SetTransmit, OnSetTransmit_T) || 
					playerTeam[client] == 3 && SDKHookEx(skin, SDKHook_SetTransmit, OnSetTransmit_CT))
				{
					setGlowTeam(skin, playerTeam[client]);
				}
			}
			else
			{
				if (SDKHookEx(skin, SDKHook_SetTransmit, OnSetTransmit_All))
				{
					setGlowTeam(skin, playerTeam[client]);
				}
			}
		}
	}
}

public void setGlowTeam(int skin, int team)
{
	if (team >= 2)
	{
		SetupGlow(skin, colors[team - 2]);
	}
}

public Action OnSetTransmit_All(int entity, int client)
{
	if (canSeeESP[client] && playerModelsIndex[client] != entity)
	{
		return Plugin_Continue;
	}
	
	return Plugin_Stop;
}

public Action OnSetTransmit_T(int entity, int client)
{
	if (canSeeESP[client] && playerModelsIndex[client] != entity && playerTeam[client] == 2)
	{
		return Plugin_Continue;
	}
	
	return Plugin_Handled;
}
public Action OnSetTransmit_CT(int entity, int client)
{
	if (canSeeESP[client] && playerModelsIndex[client] != entity && playerTeam[client] == 3)
	{
		return Plugin_Continue;
	}
	
	return Plugin_Handled;
}

public void SetupGlow(int entity, int color[4])
{
	static int offset;
	
	if (!offset && (offset = GetEntSendPropOffs(entity, "m_clrGlow")) == -1)
	{
		LogError("Incapaz de encontrar deslocamento de propriedade: \"m_clrGlow\"!");
		return;
	}
	
	SetEntProp(entity, Prop_Send, "m_bShouldGlow", true);
	SetEntProp(entity, Prop_Send, "m_nGlowStyle", 0);
	SetEntPropFloat(entity, Prop_Send, "m_flGlowMaxDist", 10000.0);
	
	for (int i = 0; i < 3; i++)
	{
		SetEntData(entity, offset + i, color[i], _, true);
	}
}

public int CreatePlayerModelProp(int client, char[] sModel, char[] attachment, bool bonemerge, float scale)
{
	RemoveSkin(client);
	int skin = CreateEntityByName("prop_dynamic_glow");
	DispatchKeyValue(skin, "model", sModel);
	DispatchKeyValue(skin, "solid", "0");
	DispatchKeyValue(skin, "fademindist", "1");
	DispatchKeyValue(skin, "fademaxdist", "1");
	DispatchKeyValue(skin, "fadescale", "2.0");
	SetEntProp(skin, Prop_Send, "m_CollisionGroup", 0);
	DispatchSpawn(skin);
	SetEntityRenderMode(skin, RENDER_GLOW);
	SetEntityRenderColor(skin, 0, 0, 0, 0);
	
	if (bonemerge) {
		SetEntProp(skin, Prop_Send, "m_fEffects", EF_BONEMERGE);
	}
	
	if (scale != 1.0) {
		SetEntPropFloat(skin, Prop_Send, "m_flModelScale", scale);
	}
	
	SetVariantString("!activator");
	AcceptEntityInput(skin, "SetParent", client, skin);
	SetVariantString(attachment);
	AcceptEntityInput(skin, "SetParentAttachment", skin, skin, 0);
	SetVariantString("OnUser1 !self:Kill::0.1:-1");
	AcceptEntityInput(skin, "AddOutput");
	playerModels[client] = EntIndexToEntRef(skin);
	playerModelsIndex[client] = skin;
	
	return skin;
}

public void RemoveSkin(int client)
{
	int index = EntRefToEntIndex(playerModels[client]);
	
	if (index > MaxClients && IsValidEntity(index))
	{
		SetEntProp(index, Prop_Send, "m_bShouldGlow", false);
		AcceptEntityInput(index, "FireUser1");
	}
	
	playerModels[client] = INVALID_ENT_REFERENCE;
	playerModelsIndex[client] = -1;
}


////////////
//ADMIN MENU
////////////

public void OnAllPluginsLoaded()
{
	if (!LibraryExists("especialrounds")) //WITH ESPECIALS ROUNDS
	{
		Handle topmenu;
		if (LibraryExists("adminmenu") && ((topmenu = GetAdminTopMenu()) != null))
			OnAdminMenuReady(topmenu);
	}
}

public void OnAdminMenuReady(Handle topmenu)
{
	if (topmenu == hAdminMenu)
		return;
	
	hAdminMenu = topmenu;
	CreateTimer(1.0, Timer_AttachAdminMenu);
}

public Action Timer_AttachAdminMenu(Handle timer)
{
	TopMenuObject menu_category = AddToTopMenu(hAdminMenu, "wallhackround", TopMenuObject_Category, Handle_Category, INVALID_TOPMENUOBJECT, "wallhackround", ADMFLAG_GENERIC);
	if (menu_category == INVALID_TOPMENUOBJECT)
		return;
	
	AddToTopMenu(hAdminMenu, "sm_whround", TopMenuObject_Item, AdminMenu_WallhackRound, menu_category, "sm_whround", ADMFLAG_GENERIC);
}

public void Handle_Category(TopMenu topmenu, TopMenuAction action, TopMenuObject topobj_id, int param, char[] buffer, int maxlength)
{
	if (action == TopMenuAction_DisplayTitle)
		Format(buffer, maxlength, "%T", "Wall Hack Round Title in Admin", param);
	else if (action == TopMenuAction_DisplayOption)
		Format(buffer, maxlength, "%T", "Wall Hack Round Title in Admin", param);
}

public void AdminMenu_WallhackRound(TopMenu topmenu, TopMenuAction action, TopMenuObject topobj_id, int param, char[] buffer, int maxlength)
{
	if (action == TopMenuAction_DisplayOption)
		Format(buffer, maxlength, "%T", "Wall Hack Round Buttom in Admin", param);
	else if (action == TopMenuAction_SelectOption)
		ShowMenu(param);
} 